<html>
    <head>
        <script src="js/third_party/ag-grid.min.js"></script>
        <script src="js/third_party/jquery-3.4.1.min.js"></script>
        <script src="js/nestorpi/util.js" ></script>
        <script src="js/nestorpi/webrtc.js" ></script>
        <style type="text/css">
.cell {
    display: flex;
    align-items: center;
    justify-content: center;
}
footer {
    text-align: center;
}
        </style>
    </head>
    <body>
        <div id="myGrid" style="height: 80%;" class="ag-fresh"></div>
        <footer id="footer"></footer>
    </body>
    <script>
        // columns
        var columnDefs = [
            { headerName: "Peerid" , field: "peerid",  cellClass: "cell" },
            { headerName: "Stream", field: "streamid",  cellClass: "cell" },
            { headerName: "Size", field: "size",  cellClass: "cell" },
            { headerName: "Action" , cellClass: "cell",
                field: "action",
                cellRenderer: function(params) {
                    var eDiv = document.createElement('div');
                    var eButton = document.createElement('button');
                    eButton.innerHTML = params.value;
                    eDiv.appendChild(eButton);
                    eButton.addEventListener('click', function() {
                        user = read_cookie("username")
                        passwd = read_cookie("password")
                        if (user == null) alert("Please log in first!");
                        $.get( "/api/hangup?peer_id=" + params.data.peerid + "&user=" + user + "&passwd=" + passwd)
                    });
                    return eDiv;
                }
            }
        ];

// options
var gridOptions = {
    enableFilter: true,
    enableSorting: true,
    enableColResize: true,
    columnDefs: columnDefs,
    onGridReady: function($event) { $event.api.sizeColumnsToFit(); }
};

// fill grid
new agGrid.Grid(document.querySelector('#myGrid'), gridOptions);

// ------------------------------------------
// init device list
// ------------------------------------------
function onGetPeerConnectionList(peerConnectionList) {

    var rowData = [];
    peerConnectionList.forEach(function(item) {
        var peerConnection = Object.values(item)[0];

        var streamid = "";
        var frameHeight = 0;
        var frameWidth = 0;
        if (peerConnection.hasOwnProperty("streams")){
            streamid = Object.keys(peerConnection.streams)[0];

            var stream = Object.values(peerConnection.streams)[0];
            Object.entries(stream).forEach( ([key, value]) => {
                if (value.hasOwnProperty("width")) {
                    frameHeight = value.width;
                }
                if (value.hasOwnProperty("height")) {
                    frameWidth = value.height;
                }
            });
        }

        rowData.push({peerid: Object.keys(item)[0] , streamid, size:frameHeight+"x"+frameWidth, action:"hangup" })
    });
    gridOptions.api.setRowData(rowData);
}

// ------------------------------------------
// Fill version
// ------------------------------------------
function getPeerConnectionList() {
    $.get( "/api/getPeerConnectionList", function( response ) {
        onGetPeerConnectionList(JSON.parse(response))
    });
}

// load
window.onload         = function() {
    getPeerConnectionList();
    window.setInterval(()=> { getPeerConnectionList(); }, 2000);
}

// unload
window.onbeforeunload = function() {
}
    </script>
</html>

